

var express = require('express');
var router = express.Router();
let passport = require("../config/auth");
let connection = require("../config/database")



var Article = require('../models/article');
var User = require('../models/User');



router.get('/', (req, res) => {
      let a = new Article();
      a.list(function(err,data) {
        if(!err){
          let rows = data
         // console.log('rows : ',rows)
          res.render('index.ejs',{rows:rows}); 
        }else{
          console.log(err) }
    })
    })
    
    router.get('/article/:id', (req, res) => {
        let a = new Article();
        let id = req.params.id; 
        a.detail(function(err,data) {
          if(!err){
            let rows = data
            console.log('rows : ',rows)
            res.render('detail.ejs',{rows:rows}); 
          }else{
            console.log(err) }
      },id)
      })
    
    // process the login form
    router.post('/login', passport.authenticate('local-login', {
      successRedirect: '/profile', // redirect to the secure profile section
      failureRedirect: '/login', // redirect back to the signup page if there is an error
      failureFlash: true // allow flash messages
      
    }),
      function (req, res) {
        console.log("hello");
    
        if (req.body.remember) {
          req.session.cookie.maxAge = 1000 * 60 * 3;
        } else {
          req.session.cookie.expires = false;
        }
        res.redirect('/');
      });
    
        // =====================================
        // SIGNUP ==============================
        // =====================================
        // show the signup form
        router.get('/signup', function(req, res) {
            // render the page and pass in any flash data if it exists
            res.render('signup.ejs', {  });
        });
      
        // process the signup form
        router.post('/signup', passport.authenticate('local-signup', {
            successRedirect : '/profile', // redirect to the secure profile section
            failureRedirect : '/signup', // redirect back to the signup page if there is an error
            failureFlash : false // allow flash messages
      }));
      
      router.get('/profile', isLoggedIn, function(req, res) {
            res.render('profile.ejs', {
                user : req.user // get the user out of session and pass to template
            });
        });
    
    
    
    
    
    
    
    
    
    // Logout
    router.get('/logout', function(req, res){
        req.logout();
        res.redirect('/');
      });
    
    
      router.get('/login', function (req, res) {
        // render the page and pass in any flash data if it exists
        res.render('login.ejs', {  });
      });
    
    
    
    
    
      router.get('/admin', (req, res) => {
          
             let u = new User();
             u.listuser(function(err,data) {
               if(!err){
                 let rows = data
                // console.log('rows : ',rows)
                 res.render('dash.ejs',{rows:rows}); 
               }else{
                 console.log(err) }   
               })
          });
    
    
    
          router.get('/suprimer/:id', isLoggedIn, function (req, res) {
          
          let u = new User();
          let id = req.params.id; 
    
          u.remove(function(err,data) {
            if(!err){
              // let rows = data
              // console.log('rows : ',rows)
              // res.render('dash.ejs',{rows:rows}); 
              res.redirect('/admin');
    
            }else{
              console.log(err) }
        },id)
            
        });
    
    
        router.get('/modif/:id', function (req, res) {   
          let u = new User();
          let id = req.params.id;    
          u.recupere(function(err,data) {
            if(!err){
              let rows = data
               console.log('rows : ',rows)
              res.render('modif.ejs',{rows:rows}); 
            }else{
              console.log(err) }
        },id)
    
        });
    
    
        router.put('/modif/:id', function (req, res) {        
                let u = new User();
                let id = req.params.id; 
                //console.log(req.body)
                var d = {username:req.body.username, email:req.body.email}
                u.saveup(function(err,data) {
                  if(!err){
                  // res.redirect('/')          
                  }else{
                    console.log(err) }
              },d,id)              
        });
          
          

              
 
  // Derniere 
  function isLoggedIn(req, res, next) {
    
      // if user is authenticated in the session, carry on
      if (req.isAuthenticated())
        return next();
    
      // if they aren't redirect them to the home page
      res.redirect('/');
    }






    module.exports = router